<template>
    <section>
        <div class="flex">
            <div class="max-w-xs">
                <label for="wallet" class="block text-sm font-medium text-gray-700">
                    Тикер
                </label>

                <div class="mt-1 relativze rounded-md shadow-md">
                    <input
                        class="block w-full pr-10 border-gray-300 text-gray-900 focus:outline-none focus:ring-gray-500 focus:border-gray-500 sm:text-sm rounded-md"
                        v-model="inputTicker"
                        type="text"
                        name="wallet"
                        id="wallet"
                        placeholder="Например DOGE"
                        @keydown.enter="addTicker(inputTicker)"
                    />
                </div>

                <div
                    v-if="tips.length"
                    class="flex bg-white shadow-md p-1 mt-1 rounded-md shadow-md flex-wrap"
                >
                    <template
                        v-for="tip in tips"
                        :key="tip.Symbol"
                    >
                        <span
                            class="inline-flex items-center px-2 m-1 rounded-md text-xs font-medium bg-gray-300 text-gray-800 cursor-pointer"
                            @click="addTicker(tip.Symbol)"
                        >
                            {{ tip.Symbol }}
                        </span>
                    </template>
                </div>

                <div
                    v-if="error"
                    class="text-sm text-red-600"
                >
                    Такой тикер уже добавлен
                </div>
            </div>
        </div>

        <AddButton
            class="my-4"
            @add-ticker="addTicker(inputTicker)"
        />
    </section>
</template>

<script>
    import AddButton from "@/components/AddButton";

    export default {
        components: {
            AddButton
        },

        data () {
            return {
                tips: [],

                inputTicker: '',
                error: false
            }
        },

        props: {
            coinList: {
                type: Array,
                default: () => [],
            },

            tickers: {
                type: Array,
                default: () => [],
            },

            tipsCount: {
                type: Number,
                default: 4
            }
        },

        emits: {
            'add-ticker': (value) => {
                return typeof value === "string"
            }
        },

        methods: {
            addTicker (value) {
                if (this.isTickerAlreadyAdd(value)) {
                    this.error = true;
                    return;
                }

                this.$emit('add-ticker', value);
                this.inputTicker = '';
            },

            isTickerAlreadyAdd (tickerName) {
                return this.tickers.findIndex(ticker => ticker.name.toUpperCase() === tickerName.toUpperCase()) !== -1;
            },

            getTips() {
                const isEmpty = !this.inputTicker.trim();

                if (isEmpty) {
                    return [];
                }

                const fullNameCoincidence = this.coinList
                    .filter((coin) => coin.Symbol === this.inputTicker.trim().toUpperCase());

                const otherCoincidence = this.coinList
                    .filter((coin) => {
                        return coin.FullName
                            .toUpperCase()
                            .includes(this.inputTicker.trim().toUpperCase())
                    })

                return [...fullNameCoincidence, ...otherCoincidence]
                    .slice(0, this.tipsCount);
            },
        },

        watch: {
            inputTicker () {
                this.tips = this.getTips();
                this.error = false;
            },
        }
    }
</script>